import { EntityManager } from '@mikro-orm/core'

import Database from '../database'

import Logger, { LoggerType } from '#application/logger'

export abstract class BaseRepository {
  protected readonly logger = Logger.type(LoggerType.REPOSITORY)
  private entityManager?: EntityManager

  getEntityManager(): EntityManager {
    if (!this.entityManager) {
      this.entityManager = Database.getORM().em.fork()
    }
    return this.entityManager
  }
}
