import { Request, Response } from 'express'

import { BaseController } from '#application/base/baseController'
import Storage from '#application/storage'

export class TexturesController extends BaseController {
  /**
   * Download texture
   * @param req
   * @param res
   */
  public async download(req: Request, res: Response) {
    const { type, spriteId, file } = req.params

    const texture = type === 'sprites' && spriteId ? Storage.getPublicPath(type, spriteId, file) : Storage.getPublicPath(type, file)

    this.sendFile(res, texture)
  }
}
