import { BaseEvent } from '#application/base/baseEvent'
import { CharacterHair } from '#entities/characterHair'

export default class CharacterHairCreateEvent extends BaseEvent {
  public listen(): void {
    this.socket.on('gm:characterHair:create', this.handleEvent.bind(this))
  }

  private async handleEvent(data: undefined, callback: (response: boolean) => void): Promise<void> {
    try {
      if (!(await this.isCharacterGM())) return

      const newCharacterHair = new CharacterHair()
      await newCharacterHair.setName('New hair').save()

      return callback(true)
    } catch (error) {
      console.error('Error creating character hair:', error)
      return callback(false)
    }
  }
}
