import { BaseEvent } from '#application/base/baseEvent'
import { CharacterType } from '#entities/characterType'

export default class CharacterTypeCreateEvent extends BaseEvent {
  public listen(): void {
    this.socket.on('gm:characterType:create', this.handleEvent.bind(this))
  }

  private async handleEvent(data: undefined, callback: (response: boolean, characterType?: any) => void): Promise<void> {
    try {
      if (!(await this.isCharacterGM())) return

      const newCharacterType = new CharacterType()
      await newCharacterType.setName('New character type').save()

      return callback(true, newCharacterType)
    } catch (error) {
      console.error('Error creating character type:', error)
      return callback(false)
    }
  }
}
