import { BaseEvent } from '#application/base/baseEvent'
import { Item } from '#entities/item'

export default class ItemCreateEvent extends BaseEvent {
  public listen(): void {
    this.socket.on('gm:item:create', this.handleEvent.bind(this))
  }

  private async handleEvent(data: undefined, callback: (response: boolean, item?: any) => void): Promise<void> {
    try {
      if (!(await this.isCharacterGM())) return

      const newItem = new Item()
      await newItem.setName('New Item').setItemType('WEAPON').setStackable(false).setRarity('COMMON').setSprite(null).save()

      return callback(true, newItem)
    } catch (error) {
      console.error('Error creating item:', error)
      return callback(false)
    }
  }
}
